const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const inventory_transactions = sequelize.define(
    'inventory_transactions',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

txn_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"purchase_receipt",


"sale_issue",


"sale_return",


"transfer_out",


"transfer_in",


"adjustment_in",


"adjustment_out",


"writeoff",


"count_variance"

        ],

      },

quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

unit_cost: {
        type: DataTypes.DECIMAL,
      
      

      },

txn_at: {
        type: DataTypes.DATE,
      
      

      },

reference: {
        type: DataTypes.TEXT,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  inventory_transactions.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


























































//end loop



    db.inventory_transactions.belongsTo(db.branches, {
      as: 'branch',
      foreignKey: {
        name: 'branchId',
      },
      constraints: false,
    });

    db.inventory_transactions.belongsTo(db.warehouses, {
      as: 'warehouse',
      foreignKey: {
        name: 'warehouseId',
      },
      constraints: false,
    });

    db.inventory_transactions.belongsTo(db.products, {
      as: 'product',
      foreignKey: {
        name: 'productId',
      },
      constraints: false,
    });

    db.inventory_transactions.belongsTo(db.inventory_batches, {
      as: 'batch',
      foreignKey: {
        name: 'batchId',
      },
      constraints: false,
    });

    db.inventory_transactions.belongsTo(db.users, {
      as: 'performed_by',
      foreignKey: {
        name: 'performed_byId',
      },
      constraints: false,
    });

    db.inventory_transactions.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.inventory_transactions.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.inventory_transactions.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return inventory_transactions;
};


